import 'dart:io';

import 'package:eyflutter_core/eyflutter_core.dart';

class NotificationUtils {
  factory NotificationUtils() => _getInstance();

  static NotificationUtils get instance => _getInstance();
  static NotificationUtils? _instance;

  static NotificationUtils _getInstance() {
    return _instance ??= NotificationUtils._internal();
  }

  NotificationUtils._internal();

  final String _rescheduleNotifications = "ad84fee821ccd008";
  final String _closeSelfStarting = "d534fb99567ce1c0";

  /// 注册自启动通知广播【仅Android平台】
  void registerRescheduleNotifications() async {
    var isClose = await isCloseSelfStarting();
    if (Platform.isAndroid && (isClose ?? false)) {
      CloudChannelManager.instance.send(_rescheduleNotifications);
    }
  }

  /// 是否关闭自启动
  Future<bool?> isCloseSelfStarting() {
    return MmkvUtils.instance.getBool(_closeSelfStarting, part: MMkvPart.state);
  }

  /// 关闭自启动
  void closeSelfStarting() {
    MmkvUtils.instance.putBool(_closeSelfStarting, value: true, part: MMkvPart.state);
  }
}
